DECLARE FUNCTION showsamp! ()
DECLARE SUB drawstringmod (r!, cc!, txt$)
DECLARE SUB setcharmod (r!, c!, col!, char!)
DECLARE FUNCTION cvbit$ (num!)
DECLARE SUB attribline (r!, att!)
DECLARE SUB logikpipe (ch!, up!, dn!, lt!, rt!)
DECLARE FUNCTION pipechar! (typ!)
DECLARE FUNCTION pipetype! (char!)
DECLARE FUNCTION Pattview! ()

DECLARE SUB drawstring (r!, cc!, txt$)

DECLARE SUB setchar (r!, c!, col!, char!)
DECLARE FUNCTION positionlist! (total!, lst!())
DECLARE SUB statusbr (txt$)
DECLARE FUNCTION displist! (entries!, list$())
DECLARE SUB pl (txt$)
DECLARE FUNCTION printfmt$ (num!, value$, info$)
com$ = COMMAND$
IF com$ = "" THEN GOTO inputf
redhir:

IF DIR$(com$) = "" THEN com$ = com$ + ".mod"
IF DIR$(com$) = "" THEN
inputf:
    INPUT "Please input a filename (just hit enter to exit):", com$
    IF com$ = "" THEN END
    GOTO redhir
END IF



OPEN com$ FOR BINARY AS #1

DIM SHARED churline
DIM SHARED lines$(400)
DIM SHARED samplelen(32) AS LONG
DIM SHARED songpos(0 TO 127)
churline = 0
IF LOF(1) < 1080 THEN PRINT "File not big enough.": END
PRINT "Reading Data..";
pl "Reading Mod File: " + com$
pl "Length of file:" + STR$(LOF(1)) + "      In Hex:" + HEX$(LOF(1))
pl "Offset  Name & Value                    Info"
'offset length=6 value length=30 info length=46
'            1234567890123456789012345678901234567890123
'pl "------  ------------------------------  ------------------------------------"


pl printfmt$(LOC(1), "Title: " + INPUT$(20, 1), "The title of the mod.")
'lines$(7) = printfmt$(&H123456, "123456789012345678901234567890123*", "1234567890123456789012345678901234567890123*")
PRINT ".";
FOR i = 1 TO 31
pl ""
pl "        Sample" + STR$(i)

pl printfmt$(LOC(1), "Name: " + INPUT$(22, 1), "Name of sample")
ll = LOC(1)
'samplelen(i) = CVL(CHR$(0) + CHR$(0) + INPUT$(2, 1))
samplelen(i) = ASC(INPUT$(1, 1)) * 256! + ASC(INPUT$(1, 1))
'END


pl printfmt$(ll, "Length: " + STR$(samplelen(i)), "Stored as number of words")
pl printfmt$(LOC(1), "finetune value: " + STR$(ASC(INPUT$(1, 1)) AND 15), "Only last 4 bits used.")
pl printfmt$(LOC(1), "Volume: " + STR$(ASC(INPUT$(1, 1)) AND 63), "Values: 0-63")
pl printfmt$(LOC(1), "Repeat point: " + HEX$(CVI(INPUT$(2, 1))) + "h", "Number of words offset from start")
pl printfmt$(LOC(1), "Repeat length: " + HEX$(CVI(INPUT$(2, 1))) + "h", "Number of words in loop")

samplelen(i) = samplelen(i) * 2
NEXT i
PRINT ".";
pl "------  End of Samples.  ------"
pl ""
DIM SHARED biggestsong
ll = LOC(1)
songlen = ASC(INPUT$(1, 1))
pl printfmt$(ll, "Songlength:" + STR$(songlen), "Range is 1-128")
pl printfmt$(LOC(1), "Unused byte:" + STR$(ASC(INPUT$(1, 1))), "Not used")
pl printfmt$(LOC(1), "Song positions 0-127", "Press F2 to see them")
biggestsong = 0
PRINT ".";
FOR j = 0 TO 127
songpos(j) = ASC(INPUT$(1, 1))
IF songpos(j) > biggestsong THEN biggestsong = songpos(j)

NEXT j

IF biggestsong > 63 THEN PRINT "Problems loading file...": PRINT "Might be saved in wrong format.": END
PRINT ".done"
DIM SHARED Patterns(64, 4, 0 TO biggestsong) AS STRING * 4

pl printfmt$(LOC(1), "Signature: " + INPUT$(4, 1), "Should be 'M.K.'")
pl ""
pl " There will be" + STR$(biggestsong) + " patterns in this mod. (press F3 to see them)"
pl printfmt$(LOC(1), "The patterns begin here.", "")
PRINT "Loading Patterns..";
FOR i = 0 TO biggestsong
PRINT ".";
FOR h = 1 TO 64
FOR c = 1 TO 4
Patterns(h, c, i) = INPUT$(4, 1)
NEXT c, h, i
PRINT ".done"
pl "------  Done with patterns  ------"
pl ""
pl "Here's where the Sample sizes come in handy..."
pl printfmt$(LOC(1), "Sample data begins here", "Press F4 to see the sample data")
pl "        (only showing samples with data...)"

pl ""
DIM SHARED graph(320 * 4, 31) AS STRING * 1
DIM samprate AS LONG
DIM sampinc AS LONG
PRINT "Loading Samples...";
FOR i = 1 TO 31
IF samplelen(i) <> 0 THEN
    PRINT ".";
    pl printfmt$(LOC(1), "Sample" + STR$(i), "Length: " + HEX$(samplelen(i)) + "h Bytes")

    samprate = (samplelen(i) \ 321&) \ 4
    sampinc = 0
    sampnum = 1
    FOR b = 1 TO samplelen(i)
    a = ASC(INPUT$(1, 1))
    sampinc = sampinc + 1
    IF sampinc > samprate THEN IF sampnum < 320 * 4 THEN sampinc = 0: graph(sampnum, i) = CHR$(a): sampnum = sampnum + 1
    NEXT b
END IF
NEXT i
PRINT ".done"

    












'pl "*"
CLOSE
CLS
gof1:
SELECT CASE displist(churline, lines$())
CASE 27
LOCATE 24, 1
PRINT
CLS
PRINT "Exiting... ESC pressed."
END
CASE 1
GOTO gof1
CASE 2
a = positionlist(songlen, songpos())
GOTO gof1
CASE 3
GOTO gof3
CASE 4
GOTO gof4
END SELECT




gof3:
SELECT CASE Pattview
CASE 27
LOCATE 24, 1
PRINT
CLS
PRINT "Exiting... ESC pressed."
END
CASE 1
GOTO gof1
CASE 2
a = positionlist(songlen, songpos())
GOTO gof3
CASE 3
GOTO gof3
CASE 4
GOTO gof4
END SELECT

gof4:
SELECT CASE showsamp
CASE 27
LOCATE 24, 1
PRINT
CLS
PRINT "Exiting... ESC pressed."
END
CASE 1
GOTO gof1
CASE 2
a = positionlist(songlen, songpos())
GOTO gof4
CASE 3
GOTO gof3
CASE 4
GOTO gof4
END SELECT

SUB attribline (r, att)
DEF SEG = &HB800
ptr = r * 160 - 1
FOR i = 1 TO 80
POKE ptr + i * 2, att
NEXT i
END SUB

FUNCTION cvbit$ (num)
SELECT CASE num
CASE 0
cvbit$ = "0000"
CASE 1
cvbit$ = "0001"
CASE 2
cvbit$ = "0010"
CASE 3
cvbit$ = "0011"
CASE 4
cvbit$ = "0100"
CASE 5
cvbit$ = "0101"
CASE 6
cvbit$ = "0110"
CASE 7
cvbit$ = "0111"
CASE 8
cvbit$ = "1000"
CASE 9
cvbit$ = "1001"
CASE 10
cvbit$ = "1010"
CASE 11
cvbit$ = "1011"
CASE 12
cvbit$ = "1100"
CASE 13
cvbit$ = "1101"
CASE 14
cvbit$ = "1110"
CASE 15
cvbit$ = "1111"
END SELECT




END FUNCTION

FUNCTION displist (entries, list$()) STATIC

CLS
PRINT ""; STRING$(78, 205); "";
PRINT ""; STRING$(78, 32); "";
PRINT ""; STRING$(78, 32); "";
PRINT ""; STRING$(78, 32); "";
FOR i = 1 TO 3
c = LEN(list$(i))
IF c > 75 OR i = 3 THEN
LOCATE i + 1, 3
PRINT LEFT$(list$(i), 76)
ELSE
c = 40 - c \ 2
LOCATE i + 1, c
PRINT list$(i)
END IF
NEXT i

PRINT ""; STRING$(78, 205); "";
   FOR i = 1 TO 18
   PRINT ""; STRING$(78, 32); "";
   NEXT i
PRINT ""; STRING$(78, 205); "";

IF entries < 21 THEN
FOR i = 4 TO entries
LOCATE i + 2, 3
IF LEN(list$(i)) > 75 THEN PRINT LEFT$(list$(i), 76) ELSE PRINT list$(i)
NEXT i

ELSE
'up-72  dn-80

redraw:
         '00000000001111111111222222222233333333334444444444555555555566666666667777777777
         '01234567890123456789012345678901234567890123456789012345678901234567890123456789
statusbr " < ESC to exit >  < F2 - Song Positions >   < F3 - Patterns >  < F4 - Samples >"
FOR i = 4 TO 21
LOCATE i + 2, 3
PRINT STRING$(76, " ")
LOCATE i + 2, 3
IF LEN(list$(i + curtop)) > 75 THEN PRINT LEFT$(list$(i + curtop), 76) ELSE PRINT list$(i + curtop)
NEXT i

keyloop:
COLOR 7
DO: a$ = INKEY$: LOOP WHILE a$ = ""

SELECT CASE a$
CASE CHR$(0) + CHR$(72)
curtop = curtop - 1
CASE CHR$(0) + CHR$(80)
curtop = curtop + 1

CASE CHR$(0) + CHR$(73)
curtop = curtop - 16
CASE CHR$(0) + CHR$(81)
curtop = curtop + 16

CASE CHR$(0) + CHR$(59)             'f1
'displist = 1
'GOTO endsub
CASE CHR$(0) + CHR$(60)             'f2
displist = 2
GOTO endsub
CASE CHR$(0) + CHR$(61)             'f3
displist = 3
GOTO endsub
CASE CHR$(0) + CHR$(62)             'f3
displist = 4
GOTO endsub

CASE CHR$(27)
displist = 27
GOTO endsub
CASE ELSE
GOTO keyloop
END SELECT
COLOR 4
cc = cc + 1
IF cc > 1 THEN
    IF curtop < 0 THEN curtop = 0: LOCATE 2, 3: PRINT "Can't go up!"; : m = 1: GOTO keyloop
    IF curtop + 21 > entries THEN curtop = entries - 21: LOCATE 2, 3: PRINT "Can't go down!": m = 1: GOTO keyloop
ELSE
    COLOR 7
    IF curtop < 0 THEN curtop = 0: GOTO redraw
    IF curtop + 21 > entries THEN curtop = entries - 21: GOTO redraw
END IF
COLOR 7
IF m THEN m = 0: LOCATE 2, 3: PRINT "              ";
cc = 0
GOTO redraw







END IF

endsub:

END FUNCTION

SUB drawstring (r, cc, txt$)
c = cc
ptr = 1
curcol = &H7
til = ASC("~")
LENt = LEN(txt$)
DO
ch = ASC(MID$(txt$, ptr, 1))
IF ch = til THEN
    IF ptr + 2 < LENt THEN
        ptr = ptr + 1
        curcol = ASC(MID$(txt$, ptr, 1))
        ptr = ptr + 1
        ch = ASC(MID$(txt$, ptr, 1))
    ELSE
    EXIT SUB
    END IF
END IF
setchar r, c, curcol, ch
c = c + 1
ptr = ptr + 1


LOOP WHILE ptr < LENt + 1
END SUB

SUB drawstringmod (r, cc, txt$)
c = cc
ptr = 1
curcol = &H7
til = ASC("~")
LENt = LEN(txt$)
DO
ch = ASC(MID$(txt$, ptr, 1))
IF ch = til THEN
    IF ptr + 2 < LENt THEN
        ptr = ptr + 1
        curcol = ASC(MID$(txt$, ptr, 1))
        ptr = ptr + 1
        ch = ASC(MID$(txt$, ptr, 1))
    ELSE
    EXIT SUB
    END IF
END IF
setcharmod r, c, curcol, ch
c = c + 1
ptr = ptr + 1


LOOP WHILE ptr < LENt + 1

END SUB

SUB logikpipe (ch, up, dn, lt, rt)
'1  2  3  4  5  6  7  8  9  10  11
tote = SGN(up) + SGN(dn) + SGN(lt) + SGN(rt)
IF up = 1 OR up = 3 OR up = 4 OR up = 8 OR up = 9 OR up = 10 OR up = 11 THEN upl = 1
IF dn = 1 OR dn = 5 OR dn = 6 OR dn = 7 OR dn = 9 OR dn = 10 OR dn = 11 THEN dnl = 1
IF lt = 2 OR lt = 3 OR lt = 5 OR lt = 7 OR lt = 8 OR lt = 10 OR lt = 11 THEN ltl = 1
IF rt = 2 OR lt = 4 OR lt = 6 OR lt = 7 OR lt = 8 OR lt = 9 OR tl = 11 THEN ltl = 1
totl = upl + dnl + ltl + rtl
IF ch = 1 THEN upw = 1: dnw = 1
IF ch = 2 THEN ltw = 1: rtw = 1
IF ch = 3 THEN rtw = 1: dnw = 1
IF ch = 4 THEN ltw = 1: dnw = 1
IF ch = 5 THEN upw = 1: rtw = 1
IF ch = 6 THEN upw = 1: ltw = 1
IF ch = 7 THEN upw = 1: ltw = 1: rtw = 1
IF ch = 8 THEN ltw = 1: dnw = 1: rtw = 1
IF ch = 9 THEN upw = 1: dnw = 1: ltw = 1
IF ch = 10 THEN upw = 1: dnw = 1: rtw = 1
IF ch = 11 THEN upw = 1: dnw = 1: rtw = 1: ltw = 1
totw = upw + dnw + ltw + rtw
IF totl < 2 THEN EXIT SUB
IF upw = upl AND dnw = dnl AND rtw = rtl AND lfl = lfw THEN EXIT SUB
SELECT CASE totw
CASE 2
do2:
    SELECT CASE totl
    CASE 2


    CASE 3
    GOTO do3
    CASE 4
    GOTO do4
    END SELECT
CASE 3
do3:
    SELECT CASE totl
    CASE 2
    GOTO do2
    CASE 3


    CASE 4
    GOTO do4
    END SELECT
CASE 4
do4:
IF totl = 4 THEN EXIT SUB


END SELECT
END SUB

FUNCTION Pattview STATIC
CLS
PRINT ""; STRING$(78, 205); "";
PRINT ""; STRING$(78, 32); "";
PRINT ""; STRING$(78, 32); "";
PRINT ""; STRING$(78, 205); "";
FOR i = 1 TO 19
PRINT ""; STRING$(78, 32); "";
NEXT i
PRINT ""; STRING$(78, 205); "";
drawstring 3, 54, ""
drawstring 23, 54, ""
FOR i = 4 TO 22
drawstring i, 54, ""
NEXT i

'185 186 187 188 200 201 202 203 204 205 206
drawstring 1, 2, "Selected Note: ~" + CHR$(1) + "xxxx~" + CHR$(2) + "xxxx xxxxxxxx ~" + CHR$(1) + "xxxx~" + CHR$(3) + "xxxx xxxxxxxx"
drawstring 2, 2, "~" + CHR$(1) + "Sample Number   ~" + CHR$(2) + "Note Period   ~" + CHR$(3) + "Effect command"

reddraw:
LOCATE 2, 60
PRINT "Pattern"; STR$(curpat); " of"; STR$(biggestsong)

drawstring 2, 54, "PgUp/PgDn change pattern"


statusbr " < ESC to exit >  < F1 - Mod Data >   < F2 - Song Positions >  < F4 - Samples >"
FOR i = 1 TO 19
'attribline i + 3, 7
FOR c = 0 TO 3
LOCATE i + 4, c * 10 + 10
cury = i + curtop
hexxx$ = RIGHT$("00" + HEX$(ASC(Patterns(cury, c + 1, curpat))), 2) + RIGHT$("00" + HEX$(ASC(MID$(Patterns(cury, c + 1, curpat), 2, 1))), 2) + RIGHT$("00" + HEX$(ASC(MID$(Patterns(cury, c + 1, curpat), 3, 1))), 2) + RIGHT$("00" + HEX$(ASC(MID$( _
Patterns(cury, c + 1, curpat), 4, 1))), 2)
IF c = col AND i + curtop - 1 = row THEN
drawstring i + 3, c * 10 + 9, "~" + CHR$(&H10) + hexxx$
ELSE
drawstring i + 3, c * 10 + 9, hexxx$
END IF
NEXT c

NEXT i
'r = row - curtop + 4
'c = col * 10 + 9
'drawstring r, c, "~" + CHR$(&H10) + RIGHT$("00" + HEX$(
'       ASC(Patterns(row + 1, col + 1, curpat))), 2) + RIGHT$("00" + HEX$(ASC(MID$(Patterns(row
'       + 1, col + 1, curpat), 2, 1))), 2) + RIGHT$("00" + HEX$(ASC(MID$(Patterns(row + 1, col + 1, curpat), 3, 1))), 2)
'       + RIGHT$("00" + HEX$(ASC(MID$(Patterns(row + 1, col + 1, curpat), 4, 1))), 2)
r1 = ASC(MID$(Patterns(row + 1, col + 1, curpat), 1, 1))
r2 = ASC(MID$(Patterns(row + 1, col + 1, curpat), 2, 1))
r3 = ASC(MID$(Patterns(row + 1, col + 1, curpat), 3, 1))
r4 = ASC(MID$(Patterns(row + 1, col + 1, curpat), 4, 1))
LOCATE 2, 18
PRINT cvbit$(r1 \ 16);
PRINT cvbit$(r1 MOD 16); " ";

PRINT cvbit$(r2 \ 16);
PRINT cvbit$(r2 MOD 16); " ";

PRINT cvbit$(r3 \ 16);
PRINT cvbit$(r3 MOD 16); " ";

PRINT cvbit$(r4 \ 16);
PRINT cvbit$(r4 MOD 16); " ";
drawstringmod 1, 2, "Selected Note: ~" + CHR$(1) + "xxxx~" + CHR$(2) + "xxxx xxxxxxxx ~" + CHR$(1) + "xxxx~" + CHR$(3) + "xxxx xxxxxxxx"
sample = (r1 \ 16) * 16 + (r3 \ 16)
noteper = r2 + (r1 MOD 16) * 256
effect = r4 + (r3 MOD 16) * 256
drawstring 4, 56, "~" + CHR$(1) + "Sample Number:"
LOCATE 6, 60
PRINT sample; "  "
drawstring 7, 56, "~" + CHR$(2) + "Note Period:"
LOCATE 9, 60
PRINT noteper; "  "
drawstring 11, 56, "~" + CHR$(3) + "Effect:"
LOCATE 13, 60
PRINT "Effect type:"
LOCATE 14, 65
PRINT HEX$(r3 MOD 16) + "h"

LOCATE 16, 60
PRINT "Paramaters:"
LOCATE 17, 65
PRINT r4 \ 16
LOCATE 18, 65
PRINT r4 MOD 16


keyyloop:
DO: a$ = INKEY$: LOOP WHILE a$ = ""

SELECT CASE a$
CASE CHR$(0) + CHR$(72)
row = row - 1
IF row < 0 THEN row = 0
CASE CHR$(0) + CHR$(73) 'pgup
curpat = curpat - 1
IF curpat < 0 THEN curpat = 0
CASE CHR$(0) + CHR$(80)
row = row + 1
IF row > 63 THEN row = 63
CASE CHR$(0) + CHR$(81) 'pgdn
curpat = curpat + 1
IF curpat > biggestsong THEN curpat = biggestsong
CASE CHR$(0) + CHR$(75)     'left       
col = col - 1
IF col < 0 THEN col = 0
CASE CHR$(0) + CHR$(77)     'right
col = col + 1
IF col > 3 THEN col = 3

CASE CHR$(0) + CHR$(59)             'f1
Pattview = 1
GOTO enddsub
CASE CHR$(0) + CHR$(60)             'f2
Pattview = 2
GOTO enddsub
CASE CHR$(0) + CHR$(61)             'f3
'ddisplist = 3
'GOTO enddsub
CASE CHR$(0) + CHR$(62)             'f4
Pattview = 4
GOTO enddsub

CASE CHR$(27)
Pattview = 27
GOTO enddsub
CASE ELSE
GOTO keyyloop
END SELECT
IF row > curtop + 18 THEN curtop = row - 18
IF row < curtop THEN curtop = row
GOTO reddraw

enddsub:


END FUNCTION

FUNCTION pipechar (typ)
'185 186 187 188 200 201 202 203 204 205 206
'1-186 2-205 3-201 4-187 5-200 6-188 7-202 8-203 9-185 10-204 11-206
IF typ = 1 THEN pipechar = 0
IF typ = 1 THEN pipechar = 186
IF typ = 2 THEN pipechar = 205
IF typ = 3 THEN pipechar = 201
IF typ = 4 THEN pipechar = 187
IF typ = 5 THEN pipechar = 200
IF typ = 6 THEN pipechar = 188
IF typ = 7 THEN pipechar = 202
IF typ = 8 THEN pipechar = 203
IF typ = 9 THEN pipechar = 185
IF typ = 10 THEN pipechar = 204
IF typ = 11 THEN pipechar = 206


END FUNCTION

SUB pipelogic (r, c, char)
DEF SEG = &HB800
ptr = r * 160
ptr = ptr + c * 2
'185 186 187 188 200 201 202 203 204 205 206
'1-186 2-205 3-201 4-187 5-200 6-188 7-202 8-203 9-185 10-204 11-206
'1  2  3  4  5  6  7  8  9  10  11
up1 = PEEK(ptr - 160)
dn1 = PEEK(ptr + 160)
lf1 = PEEK(ptr - 2)
rt1 = PEEK(ptr + 2)
IF r = 0 THEN up1 = 0
IF c = 0 THEN lf1 = 0
IF r = 24 THEN dn1 = 0
IF c = 79 THEN rt1 = 0
up = pipetype(up1)
dn = pipetype(dn1)
lf = pipetype(lf1)
rt = pipetype(rt1)
ch = pipetype(char)
'1  2  3  4  5  6  7  8  9  10  11
logikpipe ch, up, dn, lt, rt

END SUB

FUNCTION pipetype (char)
'185 186 187 188 200 201 202 203 204 205 206
'1-186 2-205 3-201 4-187 5-200 6-188 7-202 8-203 9-186 10-204 11-206
SELECT CASE char
CASE 186
pipetype = 1
CASE 205
pipetype = 2
CASE 201
pipetype = 3
CASE 187
pipetype = 4
CASE 200
pipetype = 5
CASE 188
pipetype = 6
CASE 202
pipetype = 7
CASE 203
pipetype = 8
CASE 185
pipetype = 9
CASE 204
pipetype = 10
CASE 206
pipetype = 11
CASE ELSE
pipetype = 0
END SELECT
END FUNCTION

SUB pl (txt$)
churline = churline + 1
lines$(churline) = txt$

END SUB

FUNCTION positionlist (total, lst())
LOCATE 1, 1
PRINT STRING$(80, "*")
FOR i = 2 TO 10
LOCATE i, 1
PRINT "*"; STRING$(78, " "); "*"
NEXT i

LOCATE 11, 1
PRINT STRING$(80, "*")
LOCATE 1, 32
PRINT " Position List "
COLOR 3
LOCATE 10, 10
PRINT "Used"
LOCATE 10, 20
COLOR 4
PRINT "Unused"
COLOR 7
LOCATE 10, 40
PRINT "Press a key to return."
num = 0
FOR r = 2 TO 9
FOR c = 8 TO 70 STEP 4
LOCATE r, c
IF num >= total THEN COLOR 4 ELSE COLOR 3

PRINT RIGHT$("   " + STR$(lst(num)) + " ", 4);
num = num + 1
NEXT c, r
COLOR 7
SLEEP

END FUNCTION

FUNCTION printfmt$ (num, value$, info$)
printfmt$ = RIGHT$("00000" + HEX$(num), 6) + "  " + LEFT$(value$ + STRING$(30, " "), 30) + "  " + LEFT$(info$, 36)

END FUNCTION

SUB setchar (r, c, col, char)
DEF SEG = &HB800
ptr = r * 160
ptr = ptr + c * 2
POKE ptr, char
POKE ptr + 1, col
END SUB

SUB setcharmod (r, c, col, char)
DEF SEG = &HB800
ptr = r * 160
ptr = ptr + c * 2
'POKE ptr, char
POKE ptr + 1, col

END SUB

FUNCTION showsamp STATIC
IF samplenum = 0 THEN samplenum = 1
SCREEN 12


redrawit:
CLS
LOCATE 1, 30
PRINT "Sample" + STR$(samplenum) + " of 31 - PgUp/PgDn changes samples"
LOCATE 25, 1
PRINT " < ESC to exit >  < F1 - Information >  < F2 - Pattern List >  < F3 - Patterns >"
IF samplelen(samplenum) <> 0 THEN
h = ASC(graph(1, samplenum))
IF h > 127 THEN h = -128 + (h - 128)
h = 200 - h
PSET (0, h), 1
IF samplelen(samplenum) >= 320 * 4 THEN
FOR i = 1 TO 320 * 4
h = ASC(graph(i, samplenum))
'h = i MOD 256
IF h > 127 THEN h = -128 + (h - 128)
h = 200 - h
LINE -(i \ 2, h), 1
NEXT i
ELSE
FOR i = 1 TO samplelen(samplenum)
h = ASC(graph(i, samplenum))
'h = i MOD 256
IF h > 127 THEN h = -128 + (h - 128)
h = 200 - h
LINE -(i / samplelen(samplenum) * 640, h), 1
NEXT i
END IF
ELSE
LOCATE 5, 10
PRINT "No Sample"

END IF




keyloopmy:
DO: a$ = INKEY$: LOOP WHILE a$ = ""

SELECT CASE a$
CASE CHR$(0) + CHR$(81)
samplenum = samplenum - 1
IF samplenum < 1 THEN samplenum = 1
CASE CHR$(0) + CHR$(73)
samplenum = samplenum + 1
IF samplenum > 31 THEN samplenum = 31
CASE CHR$(0) + CHR$(59)             'f1
d = 1
GOTO eendsub
CASE CHR$(0) + CHR$(60)             'f2
d = 2
GOTO eendsub
CASE CHR$(0) + CHR$(61)             'f3
d = 3
GOTO eendsub
'CASE CHR$(0) + CHR$(62)             'f3
'd = 4
'GOTO endsub

CASE CHR$(27)
d = 27
GOTO eendsub
CASE ELSE
GOTO keyloopmy
END SELECT
GOTO redrawit








eendsub:
SCREEN 0, 0, 0
showsamp = d


END FUNCTION

SUB statusbr (txt$)
DEF SEG = &HB800
ptr = 24 * 160
FOR i = 0 TO 79
POKE ptr + i * 2 + 1, &H70
NEXT i
FOR i = 0 TO LEN(txt$) - 1
POKE ptr + i * 2, ASC(MID$(txt$, i + 1, 1))
NEXT i
   'SLEEP
END SUB

