DIM PeriodTable(36, 16) AS INTEGER
DIM finaldata(0 TO 36 * 16) AS INTEGER

FOR i = 1 TO 16
FOR nott = 1 TO 36
READ PeriodTable(nott, i)
NEXT nott, i
' 0 1 2 3 4 5 6 7 -8 -7 -6 -5 -4 -3 -2 -1
FOR i = 0 TO 35
finaldata(i * 8 + 1) = PeriodTable(i + 1, 9)   '-8
finaldata(i * 8 + 2) = PeriodTable(i + 1, 10)  '-7
finaldata(i * 8 + 3) = PeriodTable(i + 1, 11)  '-6
finaldata(i * 8 + 4) = PeriodTable(i + 1, 12)  '-5
finaldata(i * 8 + 5) = PeriodTable(i + 1, 13)  '-4
finaldata(i * 8 + 6) = PeriodTable(i + 1, 14)  '-3
finaldata(i * 8 + 7) = PeriodTable(i + 1, 15)  '-2
finaldata(i * 8 + 8) = PeriodTable(i + 1, 16)  '-1

NEXT i
finaldata(289) = PeriodTable(i, 1)    '0
finaldata(290) = PeriodTable(i, 2)   '1
finaldata(291) = PeriodTable(i, 3)   '2
finaldata(292) = PeriodTable(i, 4)    '3
finaldata(293) = PeriodTable(i, 5)    '4
finaldata(294) = PeriodTable(i, 6)    '5
finaldata(295) = PeriodTable(i, 7)    '6
finaldata(296) = PeriodTable(i, 8)     '7

CLS
PRINT "writing periods.txt"
PRINT "(period tables)"

OPEN "periods.txt" FOR OUTPUT AS #1
PRINT #1, ";This period table goes from C-1 Finetune -8 to B-3 Finetune +7"
PRINT #1, ";The periods are arranged in order from greatest to least, so the first one will be 1, then 2, and so on..."
PRINT #1, "; any value not in this table should be set to 0"
PRINT #1, ""
FOR i = 0 TO 36
LOCATE 3, 5
PRINT STR$(INT(i / 36 * 100)); "% done  "

PRINT #1, "DW";
FOR x = 1 TO 8
PRINT #1, STR$(finaldata(i * 8 + x)); ",";
NEXT x
PRINT #1, STR$(finaldata(i * 8 + 8))
NEXT i
PRINT #1, ""
PRINT #1, "; -- End of table -- "
PRINT #1, ""
CLOSE #1
LOCATE 5, 1
PRINT "writing periods1.txt, periods2.txt, periogba.txt"
PRINT "(frequency tables)"

OPEN "periods1.txt" FOR OUTPUT AS #1
OPEN "periods2.txt" FOR OUTPUT AS #2
OPEN "periogba.txt" FOR OUTPUT AS #3
PRINT #1, ";frequency table... floating point"
PRINT #2, ";frequency table... integers"
PRINT #3, ";frequency table... GBA skip table in 16:16 format  =P"
PRINT #1, ""
PRINT #2, ""
PRINT #3, ""

FOR i = 0 TO 36
LOCATE 7, 5
PRINT STR$(INT(i / 36 * 100)); "% done  "

PRINT #1, "FloatingPoint ";
PRINT #2, "DW ";
PRINT #3, "DCD ";
FOR x = 1 TO 8
freq = 7159090.5# / (finaldata(i * 8 + x) * 2)
freq2& = INT(freq)
gbafreq& = (freq / 44042.88) * 65536
IF x < 8 THEN
PRINT #1, STR$(freq); ",";
PRINT #2, STR$(freq2&); ",";
PRINT #3, "0x"; HEX$(gbafreq&); ", ";
ELSE
PRINT #1, STR$(freq)
PRINT #2, STR$(freq2&)
PRINT #3, "0x"; HEX$(gbafreq&)
END IF

NEXT x

NEXT i
PRINT #1, ""
PRINT #2, ""
PRINT #3, ""
CLOSE
LOCATE 9, 1
PRINT "done"

END

CLS

FOR i = 0 TO 36 * 16
PRINT finaldata(i);
IF i MOD 16 = 0 THEN PRINT ""
IF i MOD (16 * 8) = 0 THEN PRINT "": DO: LOOP WHILE INKEY$ = ""

NEXT i


' Tuning 0, Normal
DATA 856, 808, 762, 720, 678, 640, 604, 570, 538, 508, 480, 453
' C-1 to B-1
DATA 428, 404, 381, 360, 339, 320, 302, 285, 269, 254, 240, 226
' C-2 to B-2
DATA 214, 202, 190, 180, 170, 160, 151, 143, 135, 127, 120, 113
' C-3 to B-3
' Tuning 1
DATA 850, 802, 757, 715, 674, 637, 601, 567, 535, 505, 477, 450
' same as above
DATA 425, 401, 379, 357, 337, 318, 300, 284, 268, 253, 239, 225
' but with
DATA 213, 201, 189, 179, 169, 159, 150, 142, 134, 126, 119, 113
' finetune +1
' Tuning 2
DATA 844, 796, 752, 709, 670, 632, 597, 563, 532, 502, 474, 447
' etc,
DATA 422, 398, 376, 355, 335, 316, 298, 282, 266, 251, 237, 224
' finetune +2
DATA 211, 199, 188, 177, 167, 158, 149, 141, 133, 125, 118, 112
' Tuning 3
DATA 838, 791, 746, 704, 665, 628, 592, 559, 528, 498, 470, 444
DATA 419, 395, 373, 352, 332, 314, 296, 280, 264, 249, 235, 222
DATA 209, 198, 187, 176, 166, 157, 148, 140, 132, 125, 118, 111
' Tuning 4
DATA 832, 785, 741, 699, 660, 623, 588, 555, 524, 495, 467, 441
DATA 416, 392, 370, 350, 330, 312, 294, 278, 262, 247, 233, 220
DATA 208, 196, 185, 175, 165, 156, 147, 139, 131, 124, 117, 110
' Tuning 5
DATA 826, 779, 736, 694, 655, 619, 584, 551, 520, 491, 463, 437
DATA 413, 390, 368, 347, 328, 309, 292, 276, 260, 245, 232, 219
DATA 206, 195, 184, 174, 164, 155, 146, 138, 130, 123, 116, 109
' Tuning 6
DATA 820, 774, 730, 689, 651, 614, 580, 547, 516, 487, 460, 434
DATA 410, 387, 365, 345, 325, 307, 290, 274, 258, 244, 230, 217
DATA 205, 193, 183, 172, 163, 154, 145, 137, 129, 122, 115, 109
' Tuning 7
DATA 814, 768, 725, 684, 646, 610, 575, 543, 513, 484, 457, 431
DATA 407, 384, 363, 342, 323, 305, 288, 272, 256, 242, 228, 216
DATA 204, 192, 181, 171, 161, 152, 144, 136, 128, 121, 114, 108
' Tuning -8
DATA 907, 856, 808, 762, 720, 678, 640, 604, 570, 538, 508, 480
DATA 453, 428, 404, 381, 360, 339, 320, 302, 285, 269, 254, 240
DATA 226, 214, 202, 190, 180, 170, 160, 151, 143, 135, 127, 120
' Tuning -7
DATA 900, 850, 802, 757, 715, 675, 636, 601, 567, 535, 505, 477
DATA 450, 425, 401, 379, 357, 337, 318, 300, 284, 268, 253, 238
DATA 225, 212, 200, 189, 179, 169, 159, 150, 142, 134, 126, 119
' Tuning -6
DATA 894, 844, 796, 752, 709, 670, 632, 597, 563, 532, 502, 474
DATA 447, 422, 398, 376, 355, 335, 316, 298, 282, 266, 251, 237
DATA 223, 211, 199, 188, 177, 167, 158, 149, 141, 133, 125, 118
' Tuning -5
DATA 887, 838, 791, 746, 704, 665, 628, 592, 559, 528, 498, 470
DATA 444, 419, 395, 373, 352, 332, 314, 296, 280, 264, 249, 235
DATA 222, 209, 198, 187, 176, 166, 157, 148, 140, 132, 125, 118
' Tuning -4
DATA 881, 832, 785, 741, 699, 660, 623, 588, 555, 524, 494, 467
DATA 441, 416, 392, 370, 350, 330, 312, 294, 278, 262, 247, 233
DATA 220, 208, 196, 185, 175, 165, 156, 147, 139, 131, 123, 117
' Tuning -3
DATA 875, 826, 779, 736, 694, 655, 619, 584, 551, 520, 491, 463
DATA 437, 413, 390, 368, 347, 328, 309, 292, 276, 260, 245, 232
DATA 219, 206, 195, 184, 174, 164, 155, 146, 138, 130, 123, 116
' Tuning -2
DATA 868, 820, 774, 730, 689, 651, 614, 580, 547, 516, 487, 460
DATA 434, 410, 387, 365, 345, 325, 307, 290, 274, 258, 244, 230
DATA 217, 205, 193, 183, 172, 163, 154, 145, 137, 129, 122, 115
' Tuning -1
DATA 862, 814, 768, 725, 684, 646, 610, 575, 543, 513, 484, 457
DATA 431, 407, 384, 363, 342, 323, 305, 288, 272, 256, 242, 228
DATA 216, 203, 192, 181, 171, 161, 152, 144, 136, 128, 121, 114

