RANDOMIZE TIMER
DIM periodtable(0 TO 37 * 9) AS LONG
FOR i = 1 TO 37 * 9
READ periodtable(i)
NEXT i
CLS

SHELL "dir *.mod"
INPUT "Mod file to open?", file$
IF INSTR(file$, ".") = 0 THEN file$ = file$ + ".mod"
IF UCASE$(DIR$(file$)) <> UCASE$(file$) THEN PRINT "Invalid File!": END

fileGBA$ = LEFT$(MID$(file$, 1, INSTR(file$, ".") - 1), 8)
filegbaa$ = fileGBA$
fileGBA$ = ""
FOR i = 1 TO LEN(filegbaa$)
c$ = MID$(filegbaa$, i, 1)
c = ASC(c$)
'PRINT c, ASC("0"); "-"; ASC("9"); ","; ASC("a"); "-"; ASC("z"); ","; ASC("A"); "-"; ASC("Z")
'SLEEP
IF (ASC("0") <= c AND c <= ASC("9")) OR (ASC("a") <= c AND c <= ASC("z")) OR (ASC("A") <= c AND c <= ASC("Z")) THEN fileGBA$ = fileGBA$ + c$
NEXT i


PRINT "File:"; file$, "GBA reference:"; fileGBA$
OPEN file$ FOR BINARY AS #1


a$ = fileGBA$ + ".asm"

OPEN a$ FOR OUTPUT AS #2
PRINT #2, "     AREA ModData"; CHR$(RND * 26 + ASC("A")); CHR$(RND * 26 + ASC("A")); ",DATA,READONLY"
PRINT #2, "     EXPORT "; fileGBA$; "mod"
PRINT #2, ""
PRINT #2, ""



a$ = fileGBA$ + ".mdd"
OPEN a$ FOR OUTPUT AS #3

PRINT #2, "moddatafile"
PRINT #2, "     INCBIN "; a$
PRINT #2, "     ;Defined length file.. contains sample and pattern info.. "
PRINT #2, "     ;8 bytes for each sample 1-31 , 4 bytes for track length, then 128 bytes for tracks"
PRINT #2, "     ;The 8 bytes are:  4bytes-Loop point, 4bytes-Loop Length (top byte of loop length is volume)"


a$ = fileGBA$ + ".mdp"
OPEN a$ FOR OUTPUT AS #4

PRINT #2, "modpatterns"
PRINT #2, "     INCBIN "; a$
PRINT #2, "     ;also defined length... but not really important"
PRINT #2, "     ;the format of this has changed since mod... it is now:"
PRINT #2, "     ;  nnnn nnnn  nnnn ssss  ssss eeee  eeee eeee"
PRINT #2, "     ; Where n is the note number, s is sample, and e is effect stuff"





name$ = INPUT$(20, 1)
DIM sampledata(31, 3) AS LONG
DIM volchan(31)
FOR i = 1 TO 31
name$ = INPUT$(22, 1)
sampledata(i, 1) = ASC(INPUT$(1, 1))
a = ASC(INPUT$(1, 1))
sampledata(i, 1) = sampledata(i, 1) * 256 + a

'sampledata(i, 1) = (ASC(INPUT$(1, 1)) + ASC(INPUT$(1, 1)) * 256)
sampledata(i, 1) = sampledata(i, 1) * 2
dum$ = INPUT$(1, 1)
volchan(i) = ASC(INPUT$(1, 1))

sampledata(i, 2) = ASC(INPUT$(1, 1))
a = ASC(INPUT$(1, 1))
sampledata(i, 2) = sampledata(i, 2) * 256 + a

'sampledata(i, 2) = (ASC(INPUT$(1, 1)) + ASC(INPUT$(1, 1)) * 256)
sampledata(i, 2) = sampledata(i, 2) * 2

sampledata(i, 3) = ASC(INPUT$(1, 1))
a = ASC(INPUT$(1, 1))
sampledata(i, 3) = sampledata(i, 3) * 256 + a

'sampledata(i, 3) = (ASC(INPUT$(1, 1)) + ASC(INPUT$(1, 1)) * 256)
sampledata(i, 3) = sampledata(i, 3) * 2
NEXT i

FOR i = 1 TO 31
IF sampledata(i, 3) = 0 THEN sampledata(i, 2) = sampledata(i, 1): sampledata(i, 3) = 2
'PRINT #3, CHR$(sampledata(i, 1) MOD 256); CHR$((sampledata(i, 1) \ 256) MOD 256); CHR$(sampledata(i, 1) \ 65536); CHR$(0);
PRINT #3, CHR$(sampledata(i, 2) MOD 256); CHR$((sampledata(i, 2) \ 256) MOD 256); CHR$(sampledata(i, 2) \ 65536); CHR$(0);
PRINT #3, CHR$(sampledata(i, 3) MOD 256); CHR$((sampledata(i, 3) \ 256) MOD 256); CHR$(sampledata(i, 3) \ 65536); CHR$(volchan(i));

NEXT i


modlength = ASC(INPUT$(1, 1))
PRINT #3, CHR$(modlength); CHR$(0); CHR$(0); CHR$(0);
d$ = INPUT$(1, 1)
pats = 0
DIM trks(0 TO 127)
FOR i = 0 TO 127
trks(i) = ASC(INPUT$(1, 1))
PRINT #3, CHR$(trks(i));
IF trks(i) > pats THEN pats = trks(i)
NEXT i
CLOSE #3
sig$ = INPUT$(4, 1)
PRINT "Patterns begin at:"; HEX$(LOC(1))

FOR i = 0 TO pats
FOR ch = 0 TO 3
FOR p = 0 TO 63
a = ASC(INPUT$(1, 1))
b = ASC(INPUT$(1, 1))
c = ASC(INPUT$(1, 1))
d = ASC(INPUT$(1, 1))

period = b + (a MOD 16) * 256
sample = c \ 16 + ((a \ 16) * 16)
effect = d + (c MOD 16) * 256

FOR pp = 0 TO 37 * 9
IF period = periodtable(pp) THEN note = pp: GOTO outofperiodloop
NEXT pp
outofperiodloop:
' nnnn nnnn nnnn ssss ssss eeee eeee eeee
PRINT #4, CHR$(effect MOD 256);
PRINT #4, CHR$(((effect \ 256) MOD 16) + (sample MOD 16) * 16);
PRINT #4, CHR$((sample \ 16) + (note MOD 16) * 16);
PRINT #4, CHR$((note \ 16) MOD 256);


NEXT p, ch, i
CLOSE #4


PRINT #2, ""
PRINT #2, fileGBA$; "mod"
PRINT #2, "    DCD moddatafile,modpatterns,modsamples"
PRINT #2, ""
PRINT #2, "modsamples"
PRINT #2, "    DCD sm1,sm2,sm3,sm4,sm5,sm6,sm7,sm8,sm9,sm10"
PRINT #2, "    DCD sm11,sm12,sm13,sm14,sm15,sm16,sm17,sm18,sm19,sm20"
PRINT #2, "    DCD sm21,sm22,sm23,sm24,sm25,sm26,sm27,sm28,sm29,sm30,sm31"
PRINT #2, ""
PRINT #2, ""
PRINT "Samples Begin At:"; HEX$(LOC(1))
FOR i = 1 TO 31
PRINT #2, "sm"; RIGHT$(STR$(i), LEN(STR$(i)) - 1)
IF sampledata(i, 1) <> 0 THEN
    a$ = LEFT$(fileGBA$, 5) + "SMP." + RIGHT$(STR$(i), LEN(STR$(i)) - 1)
    PRINT #2, "     INCBIN "; a$
    
    OPEN a$ FOR OUTPUT AS #3
    PRINT "sample "; i; " starting at "; HEX$(LOC(1)); "    Length:"; HEX$(sampledata(i, 1))
    FOR p = 1 TO sampledata(i, 1)
    c = ASC(INPUT$(1, 1))
    IF c > 127 THEN c = c - 256
    c = c + 128
    PRINT #3, CHR$(c);
    NEXT p
    CLOSE #3
END IF
NEXT i



PRINT #2, ""
PRINT #2, "     END"








CLOSE
END

DATA 907, 900, 894, 887, 881, 875, 868, 862, 862
DATA 856, 850, 844, 838, 832, 826, 820, 814, 814
DATA 808, 802, 796, 791, 785, 779, 774, 768, 768
DATA 762, 757, 752, 746, 741, 736, 730, 725, 725
DATA 720, 715, 709, 704, 699, 694, 689, 684, 684
DATA 678, 675, 670, 665, 660, 655, 651, 646, 646
DATA 640, 636, 632, 628, 623, 619, 614, 610, 610
DATA 604, 601, 597, 592, 588, 584, 580, 575, 575
DATA 570, 567, 563, 559, 555, 551, 547, 543, 543
DATA 538, 535, 532, 528, 524, 520, 516, 513, 513
DATA 508, 505, 502, 498, 494, 491, 487, 484, 484
DATA 480, 477, 474, 470, 467, 463, 460, 457, 457
DATA 453, 450, 447, 444, 441, 437, 434, 431, 431
DATA 428, 425, 422, 419, 416, 413, 410, 407, 407
DATA 404, 401, 398, 395, 392, 390, 387, 384, 384
DATA 381, 379, 376, 373, 370, 368, 365, 363, 363
DATA 360, 357, 355, 352, 350, 347, 345, 342, 342
DATA 339, 337, 335, 332, 330, 328, 325, 323, 323
DATA 320, 318, 316, 314, 312, 309, 307, 305, 305
DATA 302, 300, 298, 296, 294, 292, 290, 288, 288
DATA 285, 284, 282, 280, 278, 276, 274, 272, 272
DATA 269, 268, 266, 264, 262, 260, 258, 256, 256
DATA 254, 253, 251, 249, 247, 245, 244, 242, 242
DATA 240, 238, 237, 235, 233, 232, 230, 228, 228
DATA 226, 225, 223, 222, 220, 219, 217, 216, 216
DATA 214, 212, 211, 209, 208, 206, 205, 203, 203
DATA 202, 200, 199, 198, 196, 195, 193, 192, 192
DATA 190, 189, 188, 187, 185, 184, 183, 181, 181
DATA 180, 179, 177, 176, 175, 174, 172, 171, 171
DATA 170, 169, 167, 166, 165, 164, 163, 161, 161
DATA 160, 159, 158, 157, 156, 155, 154, 152, 152
DATA 151, 150, 149, 148, 147, 146, 145, 144, 144
DATA 143, 142, 141, 140, 139, 138, 137, 136, 136
DATA 135, 134, 133, 132, 131, 130, 129, 128, 128
DATA 127, 126, 125, 125, 123, 123, 122, 121, 121
DATA 120, 119, 118, 118, 117, 116, 115, 114, 114
DATA 113, 113, 112, 111, 110, 109, 109, 108, 108

